@echo off
setlocal enabledelayedexpansion

set "devpath=.\Keal's Frontend\"

set projectname=%~1
set projectspace=%~2

Rem :: echo %projectname%

call :projectname "%~1" "%~2"
Rem :: echo %projectname%


if "%projectname%"=="" exit /b

call :killprocess "%projectname%"

If not exist "!devpath!" (
	mkdir "!devpath!"
)
If not exist "!devpath!%~n0" (
	copy "%~dpnx0" "!devpath!%~nx0"
)

set "devpathx=!devpath!!projectname!\"

If not exist "!devpathx!" (
	mkdir "!devpathx!"
)

If not exist "!devpathx!%projectname%.rc" (
	(
		echo FB_PROGRAM_ICON ICON "!devpathx!%projectname%.ico"
	) >> "!devpathx!%projectname%.rc"
)

If not exist "!devpathx!%projectname%.ico" (
	copy ".\blank disk.ico" "!devpathx!%projectname%.ico"
)

call :debugger

set options_compiler="..\Alisha's DevKit (v122-87)\FreeBASIC\fbc32.exe"
set options_exe=-x "%projectname%.exe"
set options_build=-asm intel
set options_gui=-s gui "!devpathx!%projectname%.rc"
set options_debug=-exx -g -gen gas
set options_lib=

set log="!devpathx!%projectname% ( Compile Log ).html"
set templog="!devpathx!%projectname% ( Debris ).temp"

type NUL > !log!

call :docheader
(
	echo ^<h1^>"%projectname%" Compiler Log ^(in HTML^)^</h1^>
	echo ^<h3^>%DATE% %TIME%^</h3^>

) >> !log!

set evenodd=0

if exist ".\%projectname%.exe" (
	echo ^<h3^>Now Pruning: ".\%projectname%.exe"^</h3^> >> %log%
	del /F ".\%projectname%.exe"
)

echo ^<h3^>Now Compiling: ".\%projectname%.bas" using %options_compiler%^</h3^> >> %log%

echo ^<h3^>%options_compiler% %options_exe% ".\%projectname%.bas" %options_build% %options_gui% %options_debug% %options_lib% > %templog%^</h3^> >> %log%

call :options

echo ^<table^> >> %log%
%options_compiler% %options_exe% ".\%projectname%.bas" %options_build% %options_gui% %options_debug% %options_lib% > %templog%
	
Set /A "ErrCount=0"
Set /A "ErrLine=0"

for /f "usebackq delims=" %%A in (%templog%) do (
	
	echo ^<tr^>^<td^>^<pre class="e!ErrLine!"^>%%A^</pre^>^</td^>^</tr^> >> %log%
	set /a "ErrCount+=1"
	set /a "ErrLine=1-!ErrLine!"
)

del /f %templog%

echo ^</table^> >> %log%

if %ErrCount% EQU 0 (
	if exist ".\%projectname%.exe" (
		echo ^<h3^>Successfully Compiled: ".\%projectname%.exe"^</h3^> >> %log%
	) else (
		echo ^<h3 style="color: red;"^>Failed Compiling: ".\%projectname%.exe"^</h3^> >> %log%
	)
) else (
	echo ^<h3 style="color: red;"^>Errors Compiling: ".\%projectname%.exe"^</h3^> >> %log%
)

echo ^</body^>^</html^> >> %log%

exit /b 0

:debugger

	set debugger="!devpathx!%projectname% ( SARG's FB Debugger ).cmd"

	type NUL > %debugger%

	(
		echo echo SARG's FB Debugger
		echo "%~dp0..\Alisha's DevKit (v122-87)\fbdebug_WDS_LNX\Windows 32bit\fbdebugger_new.exe" "%~dp0%projectname%.exe"
	) >> %debugger%

	Exit /B
	
:options
(
	echo ^<h3^>Using Following Options:^</h3^>
	echo ^<ul^>
	echo ^<li^>Binary:^<ul^>^<li^>%options_exe%^</li^>^</ul^>^</li^>
	echo ^<li^>Source:^<ul^>^<li^>".\%projectname%.bas"^</li^>^</ul^>^</li^>
	echo ^<li^>Build:^<ul^>^<li^>%options_build%^</li^>^</ul^>^</li^>
	echo ^<li^>Gui:^<ul^>^<li^>%options_gui%^</li^>^</ul^>^</li^>
	echo ^<li^>Debug:^<ul^>^<li^>%options_debug%^</li^>^</ul^>^</li^>
	echo ^<li^>Lib:^<ul^>^<li^>%options_lib%^</li^>^</ul^>^</li^>
	echo ^</ul^>
) >> !log!
	
	Exit /B
	
:stylesheet

(
	echo ^<style^>
 	echo 	table, td, td {
	echo 		background-color: rgba^( 196, 196, 196, 0.5 ^);
	echo  		color: Black;
	echo  	}
	echo  	td.centerx {
	echo  		text-align: center;
	echo  	}
	echo.
	echo  	pre {
	echo  	    white-space: pre-wrap;       /^* Since CSS 2.1 ^*/
	echo  	    white-space: -moz-pre-wrap;  /^* Mozilla, since 1999 ^*/
	echo  	    white-space: -pre-wrap;      /^* Opera 4-6 ^*/
	echo  	    white-space: -o-pre-wrap;    /^* Opera 7 ^*/
	echo  	    word-wrap: break-word;       /^* Internet Explorer 5.5^+ ^*/
	echo  	}
	echo.
	echo 	.e1 {
	echo  		background-color: rgba ^( 240, 240, 240, 0.4 ^);
	echo 	}
	echo.
	echo 	.e0 {
	echo  		background-color: rgba ^( 196, 196, 196, 0.3 ^);
	echo 	}
	echo ^</style^>
) >> !log!
	
	Exit /B
	

:docheader

(
	echo ^<^^!DOCTYPE html^>
	echo ^<html lang="en-us"^>
	echo ^<head^>
	echo ^<meta charset="UTF-8"^>
	echo ^<meta name="Author" content="trkeal@gmail.com http://puzzlum.net/"^>
	echo ^<meta name="GENERATOR" content="Mozilla/4.75 [en]C-CCK-MCD {U S WEST.net}	^(Win98; U^) [Netscape]"^>
	echo ^<meta name="Classification" content="project compilation"^>
	echo ^<meta name="Description" content="%projectname% ^( Keal's Batch Compiler log ^)"^>
	echo ^<meta name="KeyWords" content="%projectname%"^>
) >> !log!

(
	echo ^<title^>"%projectname%" Compiler Log ^(in HTML^)^</title^>
	echo ^<link
	echo 	rel="icon"
	echo 	type="image/png"
	echo 	href="/pzlm-assets/gfx/puzzlum.png" ^>
) >> !log!

call :stylesheet

(
	echo ^</head^>
	echo ^<body^>
	Rem :: ^<table class="wide"^>^<tbody^>
) >> !log!

	Exit /B
	
:projectname

	set projectname=%~1
	set projectspace=%~2
	
	Rem :: echo param: ^"!projectname!^"

	call :projectname_loop_a
	
	Rem :: echo result: ^"!projectname!^"
	
	Exit /B
		
:projectname_loop_a

	Rem :: echo loop a: ^"!projectname!^"

	if "!projectname:(=!"=="!projectname!" (
		call :projectname_loop_b
		Exit /B
	)
	
	set projectname=!projectname:~0,-1!
	goto :projectname_loop_a
	
	Exit /B

:projectname_loop_b

	Rem :: echo loop b: ^"!projectname!^"
	
	if "!projectname:~-1!"==" " (
		set projectname=!projectname:~0,-1!
		goto :projectname_loop_b
	)
	
	Exit /B

:killprocess
	
	Rem :: for /f "usebackq skip=2 tokens=1 delims=," %%T in (`tasklist /fi "IMAGENAME eq %~1.exe" /fo csv`) do (
		TASKKILL /F /IM "%~1.exe" /T 2>nul
	Rem :: )
	Exit /B
	